unit SQLResBuilderMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Menus;

type
  TfrmSQLResBuilderMain = class(TForm)
    btnLoad: TButton;
    btnSave: TButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    reResText: TRichEdit;
    edtDest: TEdit;
    btnChDest: TButton;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    reMessages: TRichEdit;
    Label3: TLabel;
    PopupMenu: TPopupMenu;
    pmiClear: TMenuItem;
    procedure btnLoadClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnChDestClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure pmiClearClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateResFiles(AFileName:TFileName;AResName:String);
  public
    { Public declarations }
  end;

var
  frmSQLResBuilderMain: TfrmSQLResBuilderMain;

implementation
uses ZLIB, ResNameEditor, IniFiles;
{$R *.DFM}

procedure TfrmSQLResBuilderMain.btnLoadClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    reResText.Lines.LoadFromFile(OpenDialog.FileName);
end;

procedure TfrmSQLResBuilderMain.btnSaveClick(Sender: TObject);
var SFS,DFS:TStream;
    ZFS:TCompressionStream;
    Res:Integer;
    hand:THandle;
    FName:string;
begin
  if (edtDest.Text<>'') and (frmResNameEditor.ShowModal=mrOK)
  and (frmResNameEditor.edtResName.Text<>'') then
    UpdateResFiles(OpenDialog.FileName,frmResNameEditor.edtResName.Text);
end;

procedure TfrmSQLResBuilderMain.btnChDestClick(Sender: TObject);
begin
  if SaveDialog.Execute then
    edtDest.Text:=SaveDialog.FileName
  else
    edtDest.Text:='';
end;

procedure TfrmSQLResBuilderMain.Button1Click(Sender: TObject);
var lvIniFile:TIniFile;
    lvStringList:TStringList;
    FName:String;
    cv:integer;
begin
  try
    lvIniFile:=TIniFile.Create(ExtractFilePath(ParamStr(0))+'ImportNames.ini');
    lvStringList:=TStringList.Create;
    lvIniFile.ReadSection('SQLResNames',lvStringList);
    reMessages.Lines.add('------------------------------------Update-----------------------------------------');
      with lvStringList do
        For cv:=0 to Count-1 do
        Begin
          FName:=lvIniFile.ReadString('SQLResNames',Strings[cv],'');
          reMessages.Lines.add('- Reading resource ('+Strings[cv]+')...');
          if FName<>'' then
          Begin
            reMessages.Lines.add('Creating resource ('+Strings[cv]+')...');
            UpdateResFiles(ExtractFilePath(ParamStr(0))+FName,Strings[cv]);
            reMessages.Lines.add('Done.')
          End
          else
            reMessages.Lines.add('Resource ('+Strings[cv]+') value is empty or not found.');
        End;

    lvStringList.Clear;

    lvIniFile.ReadSection('ImportResNames',lvStringList);
      with lvStringList do
        For cv:=0 to Count-1 do
        Begin
          FName:=lvIniFile.ReadString('ImportResNames',Strings[cv],'')+'.txt';
          if FName<>'.txt' then
          Begin
            reMessages.Lines.add('Creating resource ('+Strings[cv]+')...');
            UpdateResFiles(ExtractFilePath(ParamStr(0))+FName,Strings[cv]);
            reMessages.Lines.add('Done.')
          End;
        End;
    reMessages.Lines.add('Update done.');
  except
    reMessages.Lines.add(Exception(ExceptObject).Message);
  end;
end;

procedure TfrmSQLResBuilderMain.UpdateResFiles(AFileName: TFileName;AResName: String);
var SFS,DFS:TStream;
    ZFS:TCompressionStream;
    Res:Integer;
    hand:THandle;
    FName:string;
begin
  if (edtDest.Text<>'') then
  try
    SFS:=TFileStream.Create(AFileName,fmOpenRead);
    Res:=SFS.Size;
    FName:=ExtractFilePath(ParamStr(0))+Copy(ExtractFileName(AFileName),1,Pos('.',ExtractFileName(AFileName))-1)+'.zip';
    DFS:=TFileStream.Create(FName,fmCreate);
    ZFS:=TCompressionStream.Create(clMax,DFS);
    ZFS.WriteBuffer(Res,sizeOf(Res));
    ZFS.CopyFrom(SFS,Res);

    FreeAndNil(ZFS);
    FreeAndNil(SFS);
    FreeAndNil(DFS);

    reMessages.Lines.add('Temporary zip file ('+FName+') created.');

    DFS:=TMemoryStream.Create;
    SFS:=TFileStream.Create(FName,fmOpenRead);
    DFS.CopyFrom(SFS,SFS.Size);
    DFS.Seek(0,soFromBeginning);
    hand:=BeginUpdateResource(PChar(edtDest.Text),false);
    UpdateResource(hand,RT_RCDATA,PChar(AResName),LANG_HUNGARIAN,TMemoryStream(DFS).Memory,DFS.Size);
    EndUpdateResource(hand,false);

    reMessages.Lines.add('Resource ('+AResName+') created.');
  finally
    FreeAndNil(ZFS);
    FreeAndNil(DFS);
    FreeAndNil(SFS);
  end;
  if DeleteFile(FName) then
    reMessages.Lines.add('Temporary zip file ('+FName+') deleted.');
end;

procedure TfrmSQLResBuilderMain.pmiClearClick(Sender: TObject);
begin
  if PopupMenu.PopupComponent is TRichEdit then
    TRichEdit(PopupMenu.PopupComponent).lines.Clear;
end;

procedure TfrmSQLResBuilderMain.FormShow(Sender: TObject);
begin
  SaveDialog.InitialDir:=ExtractFilePath(ParamStr(0));
end;

end.
